/*  Copyright (c) 2007-2008 Tomasz Moń
 *  Copyright (c) 2004 Artur Gajda <ag@net13.org>
 *  Copyright (c) 2004 Jakub Zawadzki <darkjames@darkjames.ath.cx>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; under version 3 of the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses>.
 */

#ifndef NET_H
#define NET_H

#include <glib.h>

#define MAXLEN 255
#define S_PORT 16127
#define BUF   4096
#define MAXIP 3
#define PING_TIMEOUT 120

#define RC_MESSAGE 0
#define RC_INIT 1
#define RC_NICKCHANGE 2
#define RC_QUIT 3
#define RC_ME 4
#define RC_PING 5
#define RC_NICKPROTEST 6
#define RC_TOPIC 7
#define RC_NEWTOPIC 8
#define RC_AWAY 9
#define RC_REAWAY 10
#define RC_KICK 11
#define RC_POP 12
#define RC_REPOP 13
#define RC_KICKED 14
#define RC_IGNORE 15
#define RC_NOIGNORE 16
#define RC_REPOPIGNORED 17
#define RC_ECHOMSG 18
#define RC_PINGAWAY 19
#define RC_FILEPROPOSE 20
#define RC_FILEREQUEST 21
#define RC_FILECANCEL 23

struct INFO {
	char host[50];
	char os[20];
	char prog[18];
	char version[2];
	char away;
	char master;
	int slowa;
	char user[32];
	char kod;
	char gender;
	int online;
	char filetransfer;
	char pisze;
} inf;

struct PAKIET {
	char header[11];
	int size;
	int fromid;
	int toid;
	char nick[30];
	int type;
	union {
  	  char data[256];
	  struct INFO rc_ping;
	} data;
	unsigned char format[10];
} hsnd;

extern int nr;
extern gchar *topic;
extern gboolean away;
extern char hostname[50];
extern int slowa;
extern gboolean composing;

int send_message(char *txt);
int send_priv_message(char *txt, int toid);
int send_pop_message(const char *txt, int toid);
int send_me(char *txt);
int send_new_topic(char *topic);
int send_topic(char *topic);
int send_away(char *txt);
void send_quit();
void change_nick(char *nick);
void send_ping();
int net_start();
int send_reaway();
int sendpacket(struct PAKIET* pakiet, int typ, int toid, char *datagram);

#endif
